(define (domain mystery-strips)
   (:predicates
       (fuel ?x)
       (volume ?x)
       (city ?x)
       (truck ?x)
       (package ?x)
       (connected ?n1 ?n2)
       (at ?v ?n)
       (in ?c ?v)
       (available_fuel ?n ?a)
       (free_volume ?v ?s)
       (d_fuel ?i ?j)
       (d_volume ?i ?j))

   (:action load
       :parameters (?c ?v ?n ?s1 ?s2)
       :precondition (and (package ?c)
			  (truck ?v)
			  (at ?c ?n)
                          (at ?v ?n)
			  (city ?n)
                          (free_volume ?v ?s2)
			  (volume ?s2)
			  (d_volume ?s1 ?s2)
                          (volume ?s1))
       :effect (and (not (at ?c ?n))
                    (in ?c ?v)
                    (not (free_volume ?v ?s2))
                    (free_volume ?v ?s1)))
   (:action move
       :parameters (?v ?n1 ?n2 ?l1 ?l2)
       :precondition (and (at ?v ?n1)
			  (city ?n1)
			  (truck ?v)
                          (connected ?n1 ?n2)
			  (city ?n2)
                          (available_fuel ?n1 ?l2)
                          (d_fuel ?l1 ?l2))
       :effect (and (not (at ?v ?n1))
                    (at ?v ?n2)
                    (not (available_fuel ?n1 ?l2))
                    (available_fuel ?n1 ?l1)))
   (:action unload
       :parameters (?c ?v ?n ?s1 ?s2)
       :precondition (and (in ?c ?v)
			  (package ?c)
			  (truck ?v)
                          (at ?v ?n)
			  (city ?n)
			  (free_volume ?v ?s1)
                          (d_volume ?s1 ?s2))
       :effect (and (not (in ?c ?v))
                    (at ?c ?n)
                    (not (free_volume ?v ?s1))
                    (free_volume ?v ?s2))))
